//+------------------------------------------------------------------+
//|                                                     Move_ATR.mq4 |
//|                                 Copyright  2009,  ForexArea.com |
//|                          http://www.automatedtradingsoftware.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009,  ForexArea.com"
#property link      "http://www.automatedtradingsoftware.com"

extern bool    USE_TS      = false; // use trailing stop or not
extern int     MA          = 66;
extern int     OFFSET      = 8;
extern string  comment1    = "0:sma,1:ema,2:smma,3:lwma";
extern int     METHOD      = 1;
extern string  comment2    = "0:close,1:open,2:high,3:low,4:median,5:typical,6:weighted";
extern int     APPLY_TO    = 4;
extern int     TF          = 5; // timeframe to use the trailing on (safety precaution)
extern int     BUFFER      = 10; // distance above/below MA to trail

double dXecn = 1;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   if(Digits==3||Digits==5){
      dXecn=10;
   }  
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectDelete("TS");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   double dATRStopLoss = iMA(NULL,0,MA,OFFSET,METHOD,APPLY_TO,1);
   
   string sStatus = "OFF";
   
   if(USE_TS == true) sStatus = "ON";
   
   if(ObjectFind("TS") != 0){
      ObjectCreate( "TS", OBJ_LABEL, 0, 0, 0 );
	   ObjectSet( "TS", OBJPROP_COLOR, White );
      ObjectSet( "TS", OBJPROP_CORNER, 0 );
      ObjectSet( "TS", OBJPROP_XDISTANCE, 4 );
      ObjectSet( "TS", OBJPROP_YDISTANCE,  30 );
      ObjectSetText( "TS", Symbol() + " Trailing stop is " + sStatus, 10 );
   }else{
     ObjectSetText( "TS", Symbol() + " Trailing stop is " + sStatus, 10 );
   }
    
	int iOrderCnt = CountOrders();

	if(iOrderCnt != 0 && USE_TS == true && Period() == TF) TrailOrders(dATRStopLoss);   
//----
   return(0);
  }
//+------------------------------------------------------------------+

int CountOrders(){
     int iCnt;
     for(int i=0;i<OrdersTotal();i++)
     {
     if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
     if(OrderSymbol()==Symbol())
     {
          if(OrderType() == OP_BUY || OrderType() == OP_SELL){
               iCnt++;
          }
     }
     }
     return(iCnt);     
}

int TrailOrders(double dTS){
     int iCnt;
     double dNewSL;
     for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()==Symbol())
      {
        if(OrderType() == OP_BUY || OrderType() == OP_SELL){
             switch(OrderType()){
                case OP_BUY:
                   dNewSL = (dTS)-((dXecn*BUFFER)*Point);
                   if(dTS < Bid && OrderStopLoss() < dNewSL || OrderStopLoss() == 0 ){
                      OrderModify(OrderTicket(),OrderOpenPrice(), dNewSL,OrderTakeProfit(),0,Blue);
                   }
                   break;
                case OP_SELL:
                   dNewSL = (dTS)+((dXecn*BUFFER)*Point);
                   if(dTS > Ask && OrderStopLoss() > dNewSL || OrderStopLoss() == 0 ){   
                      OrderModify(OrderTicket(),OrderOpenPrice(), dNewSL,OrderTakeProfit(),0,Blue);
                   }
                   break;
                default:
                   break;   
             }
        }
      }
     }
     return(iCnt);     
}

